/* Letzte Bearbeitung : 30.01.1991 14:22 */

/*

   C  -  B I B L I O T H E K   fr die Makrobefehle

   des SPB-Moduls M-422-2/A von SORCUS COMPUTER GmbH

   Version 1E (Z80-I/O-Befehle)  (nderungen vorbehalten)

*/

extern m4outp();
extern m4inp();
extern int m4adr;
extern int m4err;

int siolen[2];

/* Senden eines Zeichens ber M-422-2 */

m4tmtsio(err1,modul,kanal,data)
int *err1,modul,kanal,data;
{
  int cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
     cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
     if (kanal == 0) cmd = cmd + 8;
     else
       if (kanal == 1) cmd = cmd + 9;
     if (m4err == 0) m4outp(&m4err,cmd,data);
     *err1 = m4err;
     }
   else
     *err1 = 20;
}

/* Status der Schnittstellen auf der M-422-2  */

m4siosta(err1,modul,kanal)
int *err1,modul,kanal;
{
  int stat,cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
     cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
     if (kanal == 0) cmd = cmd + 10;
     else
       if (kanal == 1) cmd = cmd + 11;
     if (m4err == 0) m4outp(&m4err,cmd,0x10);
     if (m4err == 0) m4inp(&m4err,&stat,cmd);
     *err1 = m4err;
     return(stat);
     }
   else {
     *err1 = 20;
     return(0);
     }
}

/* Empfangen eines Zeichens ber M-422-2 */

m4rcvsio(err1,modul,kanal)
int *err1,modul,kanal;
{
  int data,cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
     cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
     if (kanal == 0) cmd = cmd + 8;
     else
       if (kanal == 1) cmd = cmd + 9;
     if (m4err == 0) m4inp(&m4err,&data,cmd);
     *err1 = m4err;
     return(data);
     }
  else {
    *err1 = 20;
    return(0);
    }
}

/* Initialisierung der Schnittstellen auf der M-422-2 */

m4inisio(err1,modul,kanal,usart,baud,dum1,dum2)
int *err1,modul,kanal,usart,baud,dum1,dum2;
{
  int ctcw[9],usartd,cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
    cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
    if (kanal == 0) cmd = cmd + 8;
    else
      if (kanal == 1) cmd = cmd + 9;
    if (m4err == 0) m4outp(&m4err,0x79,1);
    if (m4err == 0) m4outp(&m4err,0x7A,1);

    ctcw[0] = 177; ctcw[1] = 128; ctcw[2] = 64; ctcw[3] = 32; ctcw[4] = 16;
    ctcw[5] = 8; ctcw[6] = 4; ctcw[7] = 2; ctcw[8] = 1;

    if (kanal == 0) {
      if (m4err == 0) m4outp(&m4err,cmd+9,0x47);
      if (m4err == 0) m4outp(&m4err,cmd+9,ctcw[baud]);
      if (m4err == 0) m4outp(&m4err,cmd+10,0x47);
      if (m4err == 0) m4outp(&m4err,cmd+10,ctcw[baud]);
      }
    else
      if (kanal == 1) {
        if (m4err == 0) m4outp(&m4err,cmd+7,0x47);
        if (m4err == 0) m4outp(&m4err,cmd+7,ctcw[baud]);
        }
    if (m4err == 0) m4outp(&m4err,cmd+2,0x18);
    if ((usart & 4) == 4) {
      if ((usart & 2) == 2) {
        usartd = 3;
        }
      else
        usartd = 1;
      }
    else
      usartd = 0;
    if ((usart & 8) == 8) {
      if ((usart & 16) == 16) {
        usartd = usartd + 0xC;
        }
      else
        usartd = usartd + 4;
      }
    else
      if ((usart & 16) == 16) {
        usartd = usartd + 8;
        }
    usartd = usartd + 0x40;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x14);
    if (m4err == 0) m4outp(&m4err,cmd+2,usartd);
    if ((usart & 32) == 32) {
      if ((usart & 64) == 64) {
        usartd = 0;
        }
      else
        usartd = 0x20;
      }
    else {
      if ((usart & 64) == 64) {
        usartd = 0x40;
        }
      else
        usartd = 0x60;
      }
    if (m4err == 0) m4outp(&m4err,cmd+2,0x15);
    if (m4err == 0) m4outp(&m4err,cmd+2,usartd+0xA);

    siolen[kanal] = usartd + 8;

    usartd = usartd << 1;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x13);
    if (m4err == 0) m4outp(&m4err,cmd+2,usartd+1);
    *err1 = m4err;
    }
  else
    *err1 = 20;
}

/* Setzen des RTS-Bits */

m4setrts(err1,modul,kanal)
int *err1,modul,kanal;
{
  int cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
    cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
    if (kanal == 0) cmd = cmd + 8;
    else
      if (kanal == 1) cmd = cmd + 9;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x15);
    siolen[kanal] = siolen[kanal] | 2;
    if (m4err == 0) m4outp(&m4err,cmd+2,siolen[kanal]);
    *err1 = m4err;
    }
  else
    *err1 = 20;
}

/* Lschen des RTS-Bits */

m4clrrts(err1,modul,kanal)
int *err1,modul,kanal;
{
  int cmd;    /* Befehlscode */

  if ((modul > 0) && (modul < 5)) {
    cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
    if (kanal == 0) cmd = cmd + 8;
    else
      if (kanal == 1) cmd = cmd + 9;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x15);
    siolen[kanal] = siolen[kanal] & 0xFD;
    if (m4err == 0) m4outp(&m4err,cmd+2,siolen[kanal]);
    *err1 = m4err;
    }
  else
    *err1 = 20;
}

/* Setzen des DTR-Bits */

m4setdtr(err1,modul,kanal)
int *err1,modul,kanal;
{
  int cmd;    /* Befehlscode */

  if ((modul > 0) & (modul < 5)) {
    cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
    if (kanal == 0) cmd = cmd + 8;
    else
      if (kanal == 1) cmd = cmd + 9;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x15);
    siolen[kanal] = siolen[kanal] | 0x80;
    if (m4err == 0) m4outp(&m4err,cmd+2,siolen[kanal]);
    *err1 = m4err;
    }
  else
    *err1 = 20;
}

/* Lschen des DTR-Bits */

m4clrdtr(err1,modul,kanal)
int *err1,modul,kanal;
{
  int cmd;    /* Befehlscode */

  if ((modul > 0) && (modul < 5)) {
    cmd = ((modul - 1) * 0x20) + 0x80;       /* Befehlscode ermitteln */
    if (kanal == 0) cmd = cmd + 8;
    else
      if (kanal == 1) cmd = cmd + 9;
    if (m4err == 0) m4outp(&m4err,cmd+2,0x15);
    siolen[kanal] = siolen[kanal] & 0x7F;
    if (m4err == 0) m4outp(&m4err,cmd+2,siolen[kanal]);
    *err1 = m4err;
    }
  else
    *err1 = 20;
}
