{.pl72}

(* Letzte Bearbeitung : 04.04.1990 14:22 *)

(*

   P A S C A L  -  B I B L I O T H E K   fr die Makrobefehle

   des SPB-Moduls M-422-2 von SORCUS COMPUTER GmbH

   Version 1D (Z80-I/O-Befehle)    (nderungen vorbehalten)

*)

var
   siolen : array[0..1] of byte;

(* Senden eines Zeichens ber M-422-2 *)

procedure ml4_tmt_sio_dat(var err1 : byte;modul,kanal,data : byte);
const
     cmd : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd,data);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;

(* Status der Schnittstellen auf der M-422-2 *)

function ml4_sio_stat(var err1 : byte;modul,kanal : byte) : byte;
const
     cmd : byte = 0;
     stat : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 10
      else
        if kanal = 1 then
          cmd := cmd + 11;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd,$10);
      if ml4_err = 0 then ml4_inport(ml4_err,stat,cmd);
      err1 := ml4_err;
      ml4_sio_stat := stat;
    end
  else
    begin
      err1 := 20;
      ml4_sio_stat := 0;
    end;
end;


(* Empfangen eines Zeichens ber M-422-2  *)

function ml4_rcv_sio_dat(var err1 : byte;modul,kanal : byte) : byte;
const
     cmd : byte = 0;
     data : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_inport(ml4_err,data,cmd);
      err1 := ml4_err;
      ml4_rcv_sio_dat := data;
    end
  else
    begin
      err1 := 20;
      ml4_rcv_sio_dat := 0;
    end;
end;

(* Initialisierung der Schnittstellen auf der M-422-2 *)

procedure ml4_init_sio(var err1 : byte;modul,kanal,usart,baud,dum1,dum2 : byte);
const
     ctcwerte : array[0..8] of byte = (177,128,64,32,16,8,4,2,1); (* 110..19200 *)
     cmd : byte = 0;
     usartdata : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,$79,1);      (* Setzen des Vorteilers /4 *)
      if ml4_err = 0 then ml4_outport(ml4_err,$7A,1);      (* Setzen des Teilers /1 *)

      if kanal = 0 then
        begin
          if ml4_err = 0 then ml4_outport(ml4_err,cmd+9,$47);
          if ml4_err = 0 then ml4_outport(ml4_err,cmd+9,ctcwerte[baud]);
          if ml4_err = 0 then ml4_outport(ml4_err,cmd+10,$47);
          if ml4_err = 0 then ml4_outport(ml4_err,cmd+10,ctcwerte[baud]);
        end
      else
        if kanal = 1 then
          begin
            if ml4_err = 0 then ml4_outport(ml4_err,cmd+7,$47);
            if ml4_err = 0 then ml4_outport(ml4_err,cmd+7,ctcwerte[baud]);
          end;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$18);
      if (usart and 4) = 4 then    (* Parity Enable *)
        if (usart and 2) = 2 then  (* Parity Even *)
          usartdata := 3
        else                       (* Parity Odd *)
          usartdata := 1
      else                         (* Parity Disable *)
        usartdata := 0;
      if (usart and 8) = 8 then
        if (usart and 16) = 16 then
          usartdata := usartdata + $C   (* 2 Stop Bits *)
        else
          usartdata := usartdata + 4    (* 1 Stop Bit *)
      else
        if (usart and 16) = 16 then
          usartdata := usartdata + 8;   (* 1 1/2 Stop Bits *)

      usartdata := usartdata + $40;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$14);
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,usartdata);

      if (usart and 32) = 32 then
        if (usart and 64) = 64 then
          usartdata := 0
        else
          usartdata := $20
      else
        if (usart and 64) = 64 then
          usartdata := $40
        else
          usartdata := $60;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$15);
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,usartdata+$A);

      siolen[kanal] := usartdata + 8; (* wird fr RTS bentigt *)

      usartdata := usartdata shl 1;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$13);
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,usartdata+1);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;

(* Setzen des RTS-Bits *)

procedure ml4_set_rts(var err1 : byte;modul,kanal : byte);
const
     cmd : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$15);
      siolen[kanal] := siolen[kanal] or 2;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,siolen[kanal]);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;

(* Lschen  des RTS-Bits *)

procedure ml4_clr_rts(var err1 : byte;modul,kanal : byte);
const
     cmd : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$15);
      siolen[kanal] := siolen[kanal] and $FD;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,siolen[kanal]);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;


(* Setzen des DTR-Bits *)

procedure ml4_set_dtr(var err1 : byte;modul,kanal : byte);
const
     cmd : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$15);
      siolen[kanal] := siolen[kanal] or $80;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,siolen[kanal]);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;

(* Lschen  des DTR-Bits *)

procedure ml4_clr_dtr(var err1 : byte;modul,kanal : byte);
const
     cmd : byte = 0;

begin
  if modul in [1..4] then
    begin
      cmd := ((modul - 1) * $20) + $80;          (* Befehlscode ermitteln *)
      if kanal = 0 then
        cmd := cmd + 8
      else
        if kanal = 1 then
          cmd := cmd + 9;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,$15);
      siolen[kanal] := siolen[kanal] and $7F;
      if ml4_err = 0 then ml4_outport(ml4_err,cmd+2,siolen[kanal]);
      err1 := ml4_err;
    end
  else
    err1 := 20;
end;




